/* Utils.c generated by valac 0.39.7, the Vala compiler
 * generated from Utils.vala, do not modify */

/*
 * Copyright (C) 2008,2009 Sebastian Pölsterl
 *
 * This file is part of GNOME DVB Daemon.
 *
 * GNOME DVB Daemon is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME DVB Daemon is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME DVB Daemon.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <time.h>


#define DVB_LOGGING_TYPE_LOGGER (dvb_logging_logger_get_type ())
#define DVB_LOGGING_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLogger))
#define DVB_LOGGING_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLoggerClass))
#define DVB_LOGGING_IS_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_LOGGER))
#define DVB_LOGGING_IS_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_LOGGING_TYPE_LOGGER))
#define DVB_LOGGING_LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLoggerClass))

typedef struct _DVBLoggingLogger DVBLoggingLogger;
typedef struct _DVBLoggingLoggerClass DVBLoggingLoggerClass;
#define _g_type_class_unref0(var) ((var == NULL) ? NULL : (var = (g_type_class_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __g_slist_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_slist_free__g_object_unref0_ (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);


extern DVBLoggingLogger* main_log;

#define DVB_UTILS_NAME_ATTRS G_FILE_ATTRIBUTE_STANDARD_TYPE "," G_FILE_ATTRIBUTE_STANDARD_NAME
#define DVB_UTILS_READ_ATTRS G_FILE_ATTRIBUTE_STANDARD_TYPE "," G_FILE_ATTRIBUTE_ACCESS_CAN_READ
const gchar* dvb_utils_get_nick_from_enum (GType enumtype,
                                           gint val);
GType dvb_logging_logger_get_type (void) G_GNUC_CONST;
void dvb_logging_logger_error (DVBLoggingLogger* self,
                               const gchar* format,
                               ...) G_GNUC_PRINTF(2,3);
gboolean dvb_utils_get_value_by_name_from_enum (GType enumtype,
                                                const gchar* name,
                                                gint* evalue);
const gchar* dvb_utils_get_name_by_value_from_enum (GType enumtype,
                                                    gint val);
void dvb_utils_mkdirs (GFile* directory,
                       GError** error);
void dvb_logging_logger_debug (DVBLoggingLogger* self,
                               const gchar* format,
                               ...) G_GNUC_PRINTF(2,3);
static void _g_object_unref0_ (gpointer var);
static inline void _g_slist_free__g_object_unref0_ (GSList* self);
gchar* dvb_utils_remove_nonalphanums (const gchar* text);
time_t dvb_utils_difftime (struct tm* t1,
                           struct tm* t2);
void dvb_utils_create_time (gint year,
                            gint month,
                            gint day,
                            gint hour,
                            gint minute,
                            gint second,
                            struct tm* result);
void dvb_utils_create_utc_time (gint year,
                                gint month,
                                gint day,
                                gint hour,
                                gint minute,
                                gint second,
                                struct tm* result);
gboolean dvb_utils_is_readable_file (GFile* file);
void dvb_utils_delete_dir_recursively (GFile* dir,
                                       GError** error);
time_t dvb_utils_t_max (time_t a,
                        time_t b);
time_t dvb_utils_t_min (time_t a,
                        time_t b);
glong dvb_utils_strdiff (const gchar* a,
                         const gchar* b,
                         glong* unmatched);
void dvb_utils_dbus_own_name (const gchar* service_name,
                              GBusAcquiredCallback cb,
                              void* cb_target);
void dvb_logging_logger_info (DVBLoggingLogger* self,
                              const gchar* format,
                              ...) G_GNUC_PRINTF(2,3);
static void __lambda4_ (void);
static void ___lambda4__gbus_name_acquired_callback (GDBusConnection* connection,
                                              const gchar* name,
                                              gpointer self);
static void __lambda5_ (void);
static void ___lambda5__gbus_name_lost_callback (GDBusConnection* connection,
                                          const gchar* name,
                                          gpointer self);
void dvb_utils_dbus_register_object (GType t_type,
                                     GBoxedCopyFunc t_dup_func,
                                     GDestroyNotify t_destroy_func,
                                     GDBusConnection* conn,
                                     const gchar* object_path,
                                     gconstpointer obj);
static guint _vala_g_dbus_connection_register_object (GType type,
                                               void* object,
                                               GDBusConnection* connection,
                                               const gchar* path,
                                               GError** error);


inline const gchar*
dvb_utils_get_nick_from_enum (GType enumtype,
                              gint val)
{
	const gchar* result = NULL;
	GEnumClass* eclass = NULL;
	GTypeClass* _tmp0_;
	GEnumValue* eval = NULL;
	GEnumClass* _tmp1_;
	GEnumValue* _tmp2_;
	_tmp0_ = g_type_class_ref (enumtype);
	eclass = (GEnumClass*) _tmp0_;
	_tmp1_ = eclass;
	eval = g_enum_get_value (_tmp1_, val);
	_tmp2_ = eval;
	if (_tmp2_ == NULL) {
		DVBLoggingLogger* _tmp3_;
		_tmp3_ = main_log;
		dvb_logging_logger_error (_tmp3_, "Utils.vala:32: Enum has no value %d", val);
		result = NULL;
		_g_type_class_unref0 (eclass);
		return result;
	} else {
		GEnumValue* _tmp4_;
		const gchar* _tmp5_;
		_tmp4_ = eval;
		_tmp5_ = (*_tmp4_).value_nick;
		result = _tmp5_;
		_g_type_class_unref0 (eclass);
		return result;
	}
	_g_type_class_unref0 (eclass);
}


inline gboolean
dvb_utils_get_value_by_name_from_enum (GType enumtype,
                                       const gchar* name,
                                       gint* evalue)
{
	gint _vala_evalue = 0;
	gboolean result = FALSE;
	GEnumClass* enumclass = NULL;
	GTypeClass* _tmp0_;
	GEnumValue* eval = NULL;
	GEnumClass* _tmp1_;
	GEnumValue* _tmp2_;
	g_return_val_if_fail (name != NULL, FALSE);
	_tmp0_ = g_type_class_ref (enumtype);
	enumclass = (GEnumClass*) _tmp0_;
	_tmp1_ = enumclass;
	eval = g_enum_get_value_by_name (_tmp1_, name);
	_tmp2_ = eval;
	if (_tmp2_ == NULL) {
		DVBLoggingLogger* _tmp3_;
		_tmp3_ = main_log;
		dvb_logging_logger_error (_tmp3_, "Utils.vala:44: Enum has no member named %s", name);
		_vala_evalue = 0;
		result = FALSE;
		_g_type_class_unref0 (enumclass);
		if (evalue) {
			*evalue = _vala_evalue;
		}
		return result;
	} else {
		GEnumValue* _tmp4_;
		gint _tmp5_;
		_tmp4_ = eval;
		_tmp5_ = (*_tmp4_).value;
		_vala_evalue = _tmp5_;
		result = TRUE;
		_g_type_class_unref0 (enumclass);
		if (evalue) {
			*evalue = _vala_evalue;
		}
		return result;
	}
	_g_type_class_unref0 (enumclass);
	if (evalue) {
		*evalue = _vala_evalue;
	}
}


inline const gchar*
dvb_utils_get_name_by_value_from_enum (GType enumtype,
                                       gint val)
{
	const gchar* result = NULL;
	GEnumClass* enumclass = NULL;
	GTypeClass* _tmp0_;
	GEnumValue* eval = NULL;
	GEnumClass* _tmp1_;
	GEnumValue* _tmp2_;
	_tmp0_ = g_type_class_ref (enumtype);
	enumclass = (GEnumClass*) _tmp0_;
	_tmp1_ = enumclass;
	eval = g_enum_get_value (_tmp1_, val);
	_tmp2_ = eval;
	if (_tmp2_ == NULL) {
		DVBLoggingLogger* _tmp3_;
		_tmp3_ = main_log;
		dvb_logging_logger_error (_tmp3_, "Utils.vala:58: Enum has no value %d", val);
		result = NULL;
		_g_type_class_unref0 (enumclass);
		return result;
	} else {
		GEnumValue* _tmp4_;
		const gchar* _tmp5_;
		_tmp4_ = eval;
		_tmp5_ = (*_tmp4_).value_name;
		result = _tmp5_;
		_g_type_class_unref0 (enumclass);
		return result;
	}
	_g_type_class_unref0 (enumclass);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


static inline void
_g_slist_free__g_object_unref0_ (GSList* self)
{
	g_slist_free_full (self, (GDestroyNotify) _g_object_unref0_);
}


void
dvb_utils_mkdirs (GFile* directory,
                  GError** error)
{
	GSList* create_dirs = NULL;
	GFile* current_dir = NULL;
	GFile* _tmp0_;
	GSList* _tmp7_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (directory != NULL);
	create_dirs = NULL;
	_tmp0_ = _g_object_ref0 (directory);
	current_dir = _tmp0_;
	while (TRUE) {
		GFile* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFile* _tmp4_;
		GFile* _tmp5_;
		GFile* _tmp6_;
		_tmp1_ = current_dir;
		if (!(_tmp1_ != NULL)) {
			break;
		}
		_tmp2_ = current_dir;
		if (g_file_query_exists (_tmp2_, NULL)) {
			break;
		}
		_tmp3_ = current_dir;
		_tmp4_ = _g_object_ref0 (_tmp3_);
		create_dirs = g_slist_prepend (create_dirs, _tmp4_);
		_tmp5_ = current_dir;
		_tmp6_ = g_file_get_parent (_tmp5_);
		_g_object_unref0 (current_dir);
		current_dir = _tmp6_;
	}
	_tmp7_ = create_dirs;
	{
		GSList* dir_collection = NULL;
		GSList* dir_it = NULL;
		dir_collection = _tmp7_;
		for (dir_it = dir_collection; dir_it != NULL; dir_it = dir_it->next) {
			GFile* _tmp8_;
			GFile* dir = NULL;
			_tmp8_ = _g_object_ref0 ((GFile*) dir_it->data);
			dir = _tmp8_;
			{
				DVBLoggingLogger* _tmp9_;
				GFile* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
				GFile* _tmp13_;
				_tmp9_ = main_log;
				_tmp10_ = dir;
				_tmp11_ = g_file_get_path (_tmp10_);
				_tmp12_ = _tmp11_;
				dvb_logging_logger_debug (_tmp9_, "Utils.vala:76: Creating %s", _tmp12_);
				_g_free0 (_tmp12_);
				_tmp13_ = dir;
				g_file_make_directory (_tmp13_, NULL, &_inner_error_);
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					g_propagate_error (error, _inner_error_);
					_g_object_unref0 (dir);
					_g_object_unref0 (current_dir);
					__g_slist_free__g_object_unref0_0 (create_dirs);
					return;
				}
				_g_object_unref0 (dir);
			}
		}
	}
	_g_object_unref0 (current_dir);
	__g_slist_free__g_object_unref0_0 (create_dirs);
}


gchar*
dvb_utils_remove_nonalphanums (const gchar* text)
{
	gchar* result = NULL;
	GRegex* regex = NULL;
	gchar* new_text = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (text != NULL, NULL);
	{
		GRegex* _tmp0_ = NULL;
		GRegex* _tmp1_;
		GRegex* _tmp2_;
		_tmp1_ = g_regex_new ("[^-_\\.a-zA-Z0-9]", 0, 0, &_inner_error_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch198_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_regex_unref0 (regex);
		regex = _tmp2_;
		_g_regex_unref0 (_tmp0_);
	}
	goto __finally198;
	__catch198_g_regex_error:
	{
		GError* e = NULL;
		DVBLoggingLogger* _tmp3_;
		GError* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = main_log;
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		dvb_logging_logger_error (_tmp3_, "Utils.vala:86: RegexError: %s", _tmp5_);
		_tmp6_ = g_strdup (text);
		result = _tmp6_;
		_g_error_free0 (e);
		_g_regex_unref0 (regex);
		return result;
	}
	__finally198:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_regex_unref0 (regex);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	{
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, text, (gssize) -1, 0, "_", 0, &_inner_error_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch199_g_regex_error;
			}
			_g_free0 (new_text);
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		_g_free0 (new_text);
		new_text = _tmp10_;
		_g_free0 (_tmp7_);
	}
	goto __finally199;
	__catch199_g_regex_error:
	{
		GError* e = NULL;
		DVBLoggingLogger* _tmp11_;
		GError* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp11_ = main_log;
		_tmp12_ = e;
		_tmp13_ = _tmp12_->message;
		dvb_logging_logger_error (_tmp11_, "Utils.vala:94: RegexError: %s", _tmp13_);
		_tmp14_ = g_strdup (text);
		result = _tmp14_;
		_g_error_free0 (e);
		_g_free0 (new_text);
		_g_regex_unref0 (regex);
		return result;
	}
	__finally199:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_free0 (new_text);
		_g_regex_unref0 (regex);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = new_text;
	_g_regex_unref0 (regex);
	return result;
}


/**
     * @returns: Difference in seconds
     */
inline time_t
dvb_utils_difftime (struct tm* t1,
                    struct tm* t2)
{
	time_t result = 0;
	time_t ts1 = 0;
	time_t ts2 = 0;
	time_t diff = 0;
	time_t _tmp0_;
	time_t _tmp1_;
	time_t _tmp2_;
	g_return_val_if_fail (t1 != NULL, 0);
	g_return_val_if_fail (t2 != NULL, 0);
	ts1 = mktime (t1);
	ts2 = mktime (t2);
	_tmp0_ = ts1;
	_tmp1_ = ts2;
	diff = _tmp0_ - _tmp1_;
	_tmp2_ = diff;
	if (_tmp2_ < ((time_t) 0)) {
		time_t _tmp3_;
		_tmp3_ = diff;
		result = -1 * _tmp3_;
		return result;
	} else {
		result = diff;
		return result;
	}
}


/**
     * Creates Time of local time
     */
static void
g_time_local (time_t time,
              struct tm* result)
{
	struct tm _result_ = {0};
	struct tm _tmp0_ = {0};
	localtime_r (&time, &_tmp0_);
	_result_ = _tmp0_;
	*result = _result_;
	return;
}


inline void
dvb_utils_create_time (gint year,
                       gint month,
                       gint day,
                       gint hour,
                       gint minute,
                       gint second,
                       struct tm* result)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	struct tm t = {0};
	time_t _tmp5_;
	struct tm _tmp6_ = {0};
	if (year >= 1900) {
		_tmp4_ = month >= 1;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		_tmp3_ = day >= 1;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		_tmp2_ = hour >= 0;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		_tmp1_ = minute >= 0;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = second >= 0;
	} else {
		_tmp0_ = FALSE;
	}
	_vala_assert (_tmp0_, "year >= 1900 && month >= 1 && day >= 1 && hour >= 0 && minute >= 0             && second >= 0");
	_tmp5_ = time (NULL);
	g_time_local (_tmp5_, &_tmp6_);
	t = _tmp6_;
	t.tm_year = year - 1900;
	t.tm_mon = month - 1;
	t.tm_mday = day;
	t.tm_hour = hour;
	t.tm_min = minute;
	t.tm_sec = second;
	*result = t;
	return;
}


/**
     * Creates Time of UTC time
     */
static void
g_time_gm (time_t time,
           struct tm* result)
{
	struct tm _result_ = {0};
	struct tm _tmp0_ = {0};
	gmtime_r (&time, &_tmp0_);
	_result_ = _tmp0_;
	*result = _result_;
	return;
}


inline void
dvb_utils_create_utc_time (gint year,
                           gint month,
                           gint day,
                           gint hour,
                           gint minute,
                           gint second,
                           struct tm* result)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	struct tm t = {0};
	time_t _tmp5_;
	struct tm _tmp6_ = {0};
	if (year >= 1900) {
		_tmp4_ = month >= 1;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		_tmp3_ = day >= 1;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		_tmp2_ = hour >= 0;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		_tmp1_ = minute >= 0;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = second >= 0;
	} else {
		_tmp0_ = FALSE;
	}
	_vala_assert (_tmp0_, "year >= 1900 && month >= 1 && day >= 1 && hour >= 0 && minute >= 0             && second >= 0");
	_tmp5_ = time (NULL);
	g_time_gm (_tmp5_, &_tmp6_);
	t = _tmp6_;
	t.tm_year = year - 1900;
	t.tm_mon = month - 1;
	t.tm_mday = day;
	t.tm_hour = hour;
	t.tm_min = minute;
	t.tm_sec = second;
	t.tm_isdst = -1;
	*result = t;
	return;
}


gboolean
dvb_utils_is_readable_file (GFile* file)
{
	gboolean result = FALSE;
	GFileInfo* info = NULL;
	GFileInfo* _tmp7_;
	GFileInfo* _tmp11_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (file != NULL, FALSE);
	{
		GFileInfo* _tmp0_ = NULL;
		GFileInfo* _tmp1_;
		GFileInfo* _tmp2_;
		_tmp1_ = g_file_query_info (file, DVB_UTILS_READ_ATTRS, 0, NULL, &_inner_error_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch200_g_error;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_object_unref0 (info);
		info = _tmp2_;
		_g_object_unref0 (_tmp0_);
	}
	goto __finally200;
	__catch200_g_error:
	{
		GError* e = NULL;
		DVBLoggingLogger* _tmp3_;
		GError* _tmp4_;
		const gchar* _tmp5_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = main_log;
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		dvb_logging_logger_error (_tmp3_, "Utils.vala:163: Could not retrieve attributes: %s", _tmp5_);
		result = FALSE;
		_g_error_free0 (e);
		_g_object_unref0 (info);
		return result;
	}
	__finally200:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gboolean _tmp6_ = FALSE;
		_g_object_unref0 (info);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp6_;
	}
	_tmp7_ = info;
	if (g_file_info_get_file_type (_tmp7_) != G_FILE_TYPE_REGULAR) {
		DVBLoggingLogger* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp8_ = main_log;
		_tmp9_ = g_file_get_path (file);
		_tmp10_ = _tmp9_;
		dvb_logging_logger_error (_tmp8_, "Utils.vala:168: %s is not a regular file", _tmp10_);
		_g_free0 (_tmp10_);
		result = FALSE;
		_g_object_unref0 (info);
		return result;
	}
	_tmp11_ = info;
	if (!g_file_info_get_attribute_boolean (_tmp11_, G_FILE_ATTRIBUTE_ACCESS_CAN_READ)) {
		DVBLoggingLogger* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		_tmp12_ = main_log;
		_tmp13_ = g_file_get_path (file);
		_tmp14_ = _tmp13_;
		dvb_logging_logger_error (_tmp12_, "Utils.vala:173: Cannot read %s", _tmp14_);
		_g_free0 (_tmp14_);
		result = FALSE;
		_g_object_unref0 (info);
		return result;
	}
	result = TRUE;
	_g_object_unref0 (info);
	return result;
}


void
dvb_utils_delete_dir_recursively (GFile* dir,
                                  GError** error)
{
	GFileEnumerator* files = NULL;
	GFileEnumerator* _tmp0_ = NULL;
	GFileEnumerator* _tmp1_;
	GFileEnumerator* _tmp2_;
	GFileEnumerator* _tmp3_;
	GFileInfo* childinfo = NULL;
	DVBLoggingLogger* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (dir != NULL);
	_tmp1_ = g_file_enumerate_children (dir, DVB_UTILS_NAME_ATTRS, 0, NULL, &_inner_error_);
	_tmp0_ = _tmp1_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (files);
		return;
	}
	_tmp2_ = _tmp0_;
	_tmp0_ = NULL;
	_g_object_unref0 (files);
	files = _tmp2_;
	_tmp3_ = files;
	if (_tmp3_ == NULL) {
		_g_object_unref0 (_tmp0_);
		_g_object_unref0 (files);
		return;
	}
	while (TRUE) {
		GFileInfo* _tmp4_ = NULL;
		GFileEnumerator* _tmp5_;
		GFileInfo* _tmp6_;
		GFileInfo* _tmp7_;
		GFileInfo* _tmp8_;
		guint32 type = 0U;
		GFileInfo* _tmp9_;
		GFile* child = NULL;
		GFileInfo* _tmp10_;
		const gchar* _tmp11_;
		GFile* _tmp12_;
		guint32 _tmp13_;
		_tmp5_ = files;
		_tmp6_ = g_file_enumerator_next_file (_tmp5_, NULL, &_inner_error_);
		_tmp4_ = _tmp6_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (childinfo);
			_g_object_unref0 (_tmp0_);
			_g_object_unref0 (files);
			return;
		}
		_tmp7_ = _tmp4_;
		_tmp4_ = NULL;
		_g_object_unref0 (childinfo);
		childinfo = _tmp7_;
		_tmp8_ = childinfo;
		if (!(_tmp8_ != NULL)) {
			_g_object_unref0 (_tmp4_);
			break;
		}
		_tmp9_ = childinfo;
		type = g_file_info_get_attribute_uint32 (_tmp9_, G_FILE_ATTRIBUTE_STANDARD_TYPE);
		_tmp10_ = childinfo;
		_tmp11_ = g_file_info_get_name (_tmp10_);
		_tmp12_ = g_file_get_child (dir, _tmp11_);
		child = _tmp12_;
		_tmp13_ = type;
		switch (_tmp13_) {
			case G_FILE_TYPE_DIRECTORY:
			{
				GFile* _tmp14_;
				_tmp14_ = child;
				dvb_utils_delete_dir_recursively (_tmp14_, &_inner_error_);
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					g_propagate_error (error, _inner_error_);
					_g_object_unref0 (child);
					_g_object_unref0 (_tmp4_);
					_g_object_unref0 (childinfo);
					_g_object_unref0 (_tmp0_);
					_g_object_unref0 (files);
					return;
				}
				break;
			}
			case G_FILE_TYPE_REGULAR:
			{
				DVBLoggingLogger* _tmp15_;
				GFile* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
				GFile* _tmp19_;
				_tmp15_ = main_log;
				_tmp16_ = child;
				_tmp17_ = g_file_get_path (_tmp16_);
				_tmp18_ = _tmp17_;
				dvb_logging_logger_debug (_tmp15_, "Utils.vala:198: Deleting file %s", _tmp18_);
				_g_free0 (_tmp18_);
				_tmp19_ = child;
				g_file_delete (_tmp19_, NULL, &_inner_error_);
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					g_propagate_error (error, _inner_error_);
					_g_object_unref0 (child);
					_g_object_unref0 (_tmp4_);
					_g_object_unref0 (childinfo);
					_g_object_unref0 (_tmp0_);
					_g_object_unref0 (files);
					return;
				}
				break;
			}
			default:
			break;
		}
		_g_object_unref0 (child);
		_g_object_unref0 (_tmp4_);
	}
	_tmp20_ = main_log;
	_tmp21_ = g_file_get_path (dir);
	_tmp22_ = _tmp21_;
	dvb_logging_logger_debug (_tmp20_, "Utils.vala:204: Deleting directory %s", _tmp22_);
	_g_free0 (_tmp22_);
	g_file_delete (dir, NULL, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (childinfo);
		_g_object_unref0 (_tmp0_);
		_g_object_unref0 (files);
		return;
	}
	_g_object_unref0 (childinfo);
	_g_object_unref0 (_tmp0_);
	_g_object_unref0 (files);
}


time_t
dvb_utils_t_max (time_t a,
                 time_t b)
{
	time_t result = 0;
	time_t _tmp0_ = 0;
	if (a < b) {
		_tmp0_ = b;
	} else {
		_tmp0_ = a;
	}
	result = _tmp0_;
	return result;
}


time_t
dvb_utils_t_min (time_t a,
                 time_t b)
{
	time_t result = 0;
	time_t _tmp0_ = 0;
	if (a < b) {
		_tmp0_ = a;
	} else {
		_tmp0_ = b;
	}
	result = _tmp0_;
	return result;
}


static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}


glong
dvb_utils_strdiff (const gchar* a,
                   const gchar* b,
                   glong* unmatched)
{
	glong _vala_unmatched = 0L;
	glong result = 0L;
	glong len_a = 0L;
	gint _tmp0_;
	gint _tmp1_;
	glong len_b = 0L;
	gint _tmp2_;
	gint _tmp3_;
	glong max = 0L;
	glong _tmp4_;
	glong _tmp5_;
	glong diff = 0L;
	g_return_val_if_fail (a != NULL, 0L);
	g_return_val_if_fail (b != NULL, 0L);
	_tmp0_ = strlen (a);
	_tmp1_ = _tmp0_;
	len_a = (glong) _tmp1_;
	_tmp2_ = strlen (b);
	_tmp3_ = _tmp2_;
	len_b = (glong) _tmp3_;
	_tmp4_ = len_a;
	_tmp5_ = len_b;
	if (_tmp4_ < _tmp5_) {
		glong _tmp6_;
		glong _tmp7_;
		glong _tmp8_;
		_tmp6_ = len_b;
		max = _tmp6_;
		_tmp7_ = len_b;
		_tmp8_ = len_a;
		_vala_unmatched = _tmp7_ - _tmp8_;
	} else {
		glong _tmp9_;
		glong _tmp10_;
		glong _tmp11_;
		_tmp9_ = len_a;
		max = _tmp9_;
		_tmp10_ = len_a;
		_tmp11_ = len_b;
		_vala_unmatched = _tmp10_ - _tmp11_;
	}
	diff = (glong) 0;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp12_ = FALSE;
			_tmp12_ = TRUE;
			while (TRUE) {
				gint _tmp14_;
				glong _tmp15_;
				gint _tmp16_;
				gint _tmp17_;
				if (!_tmp12_) {
					gint _tmp13_;
					_tmp13_ = i;
					i = _tmp13_ + 1;
				}
				_tmp12_ = FALSE;
				_tmp14_ = i;
				_tmp15_ = max;
				if (!(((glong) _tmp14_) < _tmp15_)) {
					break;
				}
				_tmp16_ = i;
				_tmp17_ = i;
				if (string_get (a, (glong) _tmp16_) != string_get (b, (glong) _tmp17_)) {
					glong _tmp18_;
					_tmp18_ = diff;
					diff = _tmp18_ + 1;
				}
			}
		}
	}
	result = diff;
	if (unmatched) {
		*unmatched = _vala_unmatched;
	}
	return result;
}


static void
__lambda4_ (void)
{
}


static void
___lambda4__gbus_name_acquired_callback (GDBusConnection* connection,
                                         const gchar* name,
                                         gpointer self)
{
	__lambda4_ ();
}


static void
__lambda5_ (void)
{
	g_warning ("Utils.vala:244: Could not acquire name");
}


static void
___lambda5__gbus_name_lost_callback (GDBusConnection* connection,
                                     const gchar* name,
                                     gpointer self)
{
	__lambda5_ ();
}


void
dvb_utils_dbus_own_name (const gchar* service_name,
                         GBusAcquiredCallback cb,
                         void* cb_target)
{
	DVBLoggingLogger* _tmp0_;
	g_return_if_fail (service_name != NULL);
	_tmp0_ = main_log;
	dvb_logging_logger_info (_tmp0_, "Utils.vala:240: Creating D-Bus service %s", service_name);
	g_bus_own_name_with_closures (G_BUS_TYPE_SESSION, service_name, G_BUS_NAME_OWNER_FLAGS_NONE, (GClosure*) ((cb == NULL) ? NULL : g_cclosure_new ((GCallback) cb, cb_target, (GClosureNotify) NULL)), (GClosure*) ((___lambda4__gbus_name_acquired_callback == NULL) ? NULL : g_cclosure_new ((GCallback) ___lambda4__gbus_name_acquired_callback, NULL, (GClosureNotify) NULL)), (GClosure*) ((___lambda5__gbus_name_lost_callback == NULL) ? NULL : g_cclosure_new ((GCallback) ___lambda5__gbus_name_lost_callback, NULL, (GClosureNotify) NULL)));
}


static guint
_vala_g_dbus_connection_register_object (GType type,
                                         void* object,
                                         GDBusConnection* connection,
                                         const gchar* path,
                                         GError** error)
{
	void *func;
	func = g_type_get_qdata (type, g_quark_from_static_string ("vala-dbus-register-object"));
	if (!func) {
		g_set_error_literal (error, G_IO_ERROR, G_IO_ERROR_FAILED, "The specified type does not support D-Bus registration");
		return 0;
	}
	return ((guint (*) (void *, GDBusConnection *, const gchar *, GError **)) func) (object, connection, path, error);
}


inline void
dvb_utils_dbus_register_object (GType t_type,
                                GBoxedCopyFunc t_dup_func,
                                GDestroyNotify t_destroy_func,
                                GDBusConnection* conn,
                                const gchar* object_path,
                                gconstpointer obj)
{
	GError * _inner_error_ = NULL;
	g_return_if_fail (conn != NULL);
	g_return_if_fail (object_path != NULL);
	{
		_vala_g_dbus_connection_register_object (t_type, obj, conn, object_path, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch201_g_io_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	goto __finally201;
	__catch201_g_io_error:
	{
		GError* e = NULL;
		DVBLoggingLogger* _tmp0_;
		GError* _tmp1_;
		const gchar* _tmp2_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp0_ = main_log;
		_tmp1_ = e;
		_tmp2_ = _tmp1_->message;
		dvb_logging_logger_error (_tmp0_, "Utils.vala:251: Could not register object '%s': %s", object_path, _tmp2_);
		_g_error_free0 (e);
	}
	__finally201:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}



